package com.company.ch12proxy.section11.DynamicProxy;

import java.lang.reflect.InvocationHandler;
import java.lang.reflect.Proxy;

/**
 * @author cbf4Life cbf4life@126.com
 *         I'm glad to share my knowledge with you all.
 */
public class DynamicProxy<T> {
	
	public static <T> T newProxyInstance(ClassLoader loader,
			Class<?>[] classes, InvocationHandler h) {
		@SuppressWarnings("unchecked")
		T newProxyInstance = (T) Proxy.newProxyInstance(loader, classes, h);
		return newProxyInstance;
	}
}
