package com.company.ch12proxy.section12.DynamicProxy;

import java.lang.reflect.Method;
import java.lang.reflect.Proxy;

/**
 * @author cbf4Life cbf4life@126.com
 *         I'm glad to share my knowledge with you all.
 */
public class DynamicProxy {
	//Ҫĸ
	private Object obj = null;

	//ͨ캯ݱ
	public DynamicProxy(Object _obj) {
		Class<? extends Object> c = _obj.getClass();
		//ɱĴ
		obj = Proxy.newProxyInstance(c.getClassLoader(), c.getInterfaces(),
				new MyInvocationHandler(_obj));
	}

	//ִдķ
	public Object exec(String methodName, Object... args) {
		//ֵ
		Object result = null;
		//еĲ
		Class<?>[] c = new Class[args.length];
		int i = 0;
		//ò
		for (Object o : args) {
			c[i] = o.getClass();
			i++;
		}
		try {
			//ݷƺͲͲҵΨһһ
			Method method = obj.getClass().getMethod(methodName, c);
			//ִи÷
			result = method.invoke(obj, args);
		} catch (Exception e) {
			e.printStackTrace();
		}

		return result;

	}
}
