package com.company.ch12proxy.section12.DynamicProxy;

import java.lang.reflect.InvocationHandler;
import java.lang.reflect.Method;

/**
 * @author cbf4Life cbf4life@126.com
 *         I'm glad to share my knowledge with you all.
 */
public class MyInvocationHandler implements InvocationHandler {
	//Ķ
	private Object target = null;
	
	//ͨ캯һ
	public MyInvocationHandler(Object _obj) {
		target = _obj;
	}
	
	//
	@Override
	public Object invoke(Object proxy, Method method, Object[] args)
			throws Throwable {
		//÷ֵ
		Object result = null;
		//ǰ֪ͨ
		before();
		//ִбķ
		result = method.invoke(target, args);
		//֪ͨ
		after();
		
		//ֵ
		return result;
	}
	
	//ǰ֪ͨ
	public void before() {
		System.out.println("ִbefore");
	}
	
	//֪ͨ
	public void after() {
		System.out.println("ִafter");
	}
	
}
