package com.company.ch24memento.section7;

import java.beans.BeanInfo;
import java.beans.Introspector;
import java.beans.PropertyDescriptor;
import java.lang.reflect.Method;
import java.util.HashMap;

/**
 * @author cbf4Life cbf4life@126.com
 * I'm glad to share my knowledge with you all.
 */
public class BeanUtils {

	//beanԼֵ뵽Hashmap
	public static HashMap<String,Object> backupProp(Object bean){
		HashMap<String,Object> result = new HashMap<String,Object>();
		try {
			//Bean
			BeanInfo beanInfo = Introspector.getBeanInfo(bean.getClass());
			//
			PropertyDescriptor[] descriptors = beanInfo.getPropertyDescriptors();
			//
			for(PropertyDescriptor des:descriptors){
				//
				String fieldName = des.getName();
				//ȡԵķ
				Method getter = des.getReadMethod();
				//ȡֵ
				Object fieldValue = getter.invoke(bean, new Object[]{});
				if(!fieldName.equalsIgnoreCase("class")){
					result.put(fieldName, fieldValue);
				}
			}
		} catch (Exception e) {
			//쳣
		}
		return result;
	}
	
	//HashMapֵصbean
	public static void restoreProp(Object bean,HashMap<String,Object> propMap){
		try {
			//Bean
			BeanInfo beanInfo = Introspector.getBeanInfo(bean.getClass());
			//
			PropertyDescriptor[] descriptors = beanInfo.getPropertyDescriptors();
			//
			for(PropertyDescriptor des:descriptors){
				//
				String fieldName = des.getName();
				//
				if(propMap.containsKey(fieldName)){
					//дԵķ
					Method setter = des.getWriteMethod();
					setter.invoke(bean, new Object[]{propMap.get(fieldName)});
				}
			}
		} catch (Exception e) {
			//쳣
			System.out.println("shit");
			e.printStackTrace();
		}
	}
	
}
