package com.company.ch25visitor.section4;

/**
 * @author cbf4Life cbf4life@126.com
 * I'm glad to share my knowledge with you all.
 */
public class Visitor implements IVisitor {
	//žĹϵ5
	private final static int MANAGER_COEFFICIENT = 5;
	
	//ԱĹϵ2
	private final static int COMMONEMPLOYEE_COEFFICIENT = 2;
	
	//ͨԱĹܺ
	private int commonTotalSalary = 0;
	
	//žĹܺ
	private int managerTotalSalary =0;
	
	//ͨԱӡ
	public void visit(CommonEmployee commonEmployee) {
		System.out.println(this.getCommonEmployee(commonEmployee));
		//ͨԱнˮܺ
		this.calCommonSlary(commonEmployee.getSalary());
	}

	//ʲžӡ
	public void visit(Manager manager) {
		System.out.println(this.getManagerInfo(manager));
		//㲿žĹܺ
		this.calManagerSalary(manager.getSalary());
	}
	
	//װϢ
	private String getBasicInfo(Employee employee){
		String info = "" + employee.getName() + "\t";
		info = info + "Ա" + (employee.getSex() == Employee.FEMALE?"Ů":"") + "\t";
		info = info + "нˮ" + employee.getSalary()  + "\t";
		
		return info;
	}
	
	//װžϢ
	private String getManagerInfo(Manager manager){
		String basicInfo = this.getBasicInfo(manager);
		String otherInfo = "ҵ"+manager.getPerformance() + "\t";
		return basicInfo + otherInfo;
	}
	
	//װͨԱϢ
	private String getCommonEmployee(CommonEmployee commonEmployee){
		String basicInfo = this.getBasicInfo(commonEmployee);
		String otherInfo = ""+commonEmployee.getJob()+"\t";
		return basicInfo + otherInfo;
	}
	
	
	//㲿žĹܺ
	private void calManagerSalary(int salary){
		this.managerTotalSalary = this.managerTotalSalary + salary *MANAGER_COEFFICIENT ;
	}
	
	//ͨԱĹܺ
	private void calCommonSlary(int salary){
		this.commonTotalSalary = this.commonTotalSalary + salary*COMMONEMPLOYEE_COEFFICIENT;
	}
	
	//ԱĹܺ
	public int getTotalSalary(){
		return this.commonTotalSalary + this.managerTotalSalary;
	}
}
