package com.company.ch32behavior.observer_vs_chain.chain;

import java.util.Random;

/**
 * @author cbf4Life cbf4life@126.com
 * I'm glad to share my knowledge with you all.
 */
public abstract class DnsServer {
	//ϼDNS˭
	private DnsServer upperServer;
	//
	public final Recorder resolve(String domain){
		Recorder recorder=null;
		if(isLocal(domain)){//Ǳܽ
			recorder = echo(domain);
		}else{//ܽ
			//ύϼDNSн
			recorder = upperServer.resolve(domain);
		}
		return recorder;
	}
	
	//ָϼDNS
	public void setUpperServer(DnsServer _upperServer){
		this.upperServer = _upperServer;
	}
	
	//ÿDNSһDNSݴZONE,Ƿڱzone
	protected abstract boolean isLocal(String domain);
	
	//ÿDNSʵֽ
	protected Recorder echo(String domain){
		Recorder recorder = new Recorder();
		//IPַ
		recorder.setIp(genIpAddress());
		recorder.setDomain(domain);
		
		return recorder;
	}
	
	//һIPַ
	protected String genIpAddress(){
		Random rand = new Random();
		String address = rand.nextInt(255) + "." + rand.nextInt(255) + "."+ rand.nextInt(255) + "."+ rand.nextInt(255);
		
		return address;
	}
}
