package com.company.ch32behavior.observer_vs_chain.observer;

import java.util.Observable;
import java.util.Observer;
import java.util.Random;

/**
 * @author cbf4Life cbf4life@126.com
 *         I'm glad to share my knowledge with you all.
 *         ÿDNSʹ۲ҲǱ۲
 */
public abstract class DnsServer extends Observable implements Observer {

	//Ҳǽյ¼Ĵ
	@Override
	public void update(Observable _observable, Object arg1) {
		Recorder recorder = (Recorder) arg1;
		//ܽ
		if (isLocal(recorder)) {
			recorder.setIp(genIpAddress());
		} else {//ܽύϼDNS
			responsFromUpperServer(recorder);
		}
		//ǩ
		sign(recorder);
	}

	//Ϊ۲ߣӹ۲,DNSϼDNSһһ
	public void setUpperServer(DnsServer dnsServer) {
		//գȻ
		super.deleteObservers();
		super.addObserver(dnsServer);
	}

	//DNSҲ֪ͨ۲
	private void responsFromUpperServer(Recorder recorder) {
		super.setChanged();
		super.notifyObservers(recorder);
	}

	//ÿDNSǩԼ
	protected abstract void sign(Recorder recorder);

	//ÿDNS붨ԼĴ
	protected abstract boolean isLocal(Recorder recorder);

	//һIPַ
	private String genIpAddress() {
		Random rand = new Random();
		String address = rand.nextInt(255) + "." + rand.nextInt(255) + "."
				+ rand.nextInt(255) + "." + rand.nextInt(255);

		return address;
	}
}
