package com.company.ch33.facade_vs_mediator.mediator;

public class Mediator extends AbsMediator {

	@Override
	public void up(ISalary _salary) {
		upSalary();
		upTax();
	}

	@Override
	public void up(IPosition _position) {
		upPosition();
		upSalary();
		upTax();
	}

	private void upTax() {
		System.out.println("˰ף");
	}

	private void downSalary() {
		System.out.println("");
	}

	private void upSalary() {
		System.out.println("ʷַ죡");
	}

	private void upPosition() {
		System.out.println("ְλǨϲ㣡");
	}

	@Override
	public void up(ITax _tax) {
		upTax();
		downSalary();
	}

	@Override
	public void down(ISalary _salary) {
		System.out.println("»ûǮã");
	}

	@Override
	public void down(IPosition _position) {
		System.out.println("ٽˣ");
	}

	@Override
	public void down(ITax _tax) {
		System.out.println("˰½");
	}

}
