package com.company.ch34;

import java.util.ArrayList;
import java.util.List;

import com.company.ch34.command.Command;
import com.company.ch34.command.DFCommand;
import com.company.ch34.command.LSCommand;

/**
 * @author cbf4Life cbf4life@126.com
 *         I'm glad to share my knowledge with you all.
 *         еﶨ
 */
public enum CommandEnum2 {
	ls(new LSCommand()), df(new DFCommand());
	
	private Command command = null;
	
	//幹캯ĿData(value)͵ƥ
	private CommandEnum2(Command _command) {
		command = _command;
	}
	
	public Command getCommand() {
		return command;
	}
	
	//еenum
	public static List<String> getNames() {
		CommandEnum2[] commandEnum = CommandEnum2.values();
		List<String> names = new ArrayList<>();
		for (CommandEnum2 c : commandEnum) {
			names.add(c.name());
		}
		
		return names;
	}
	
	public static void main(String[] args) {
		CommandEnum2 command = CommandEnum2.df;
		//		command.getCommand();
		System.out.println(CommandEnum2.df.toString());
		System.out.println(CommandEnum2.valueOf("ls").getCommand().toString());
	}
}
