package com.company.ch38mvc.controller;

import java.io.IOException;

/**
 * @author cbf4Life cbf4life@126.com
 *         I'm glad to share my knowledge with you all.
 */
public class FilterDispather implements Filter {
	//һֵջ
	private ValueStackHelper valueStackHelper = new ValueStackHelper();
	//ӦIActionDispather
	IActionDispather actionDispather = new ActionDispather();

	//serverʱҪ
	public void destroy() {

	}

	//ʵֵ
	public void doFilter(ServletRequest request, ServletResponse response,
			FilterChain chain) throws IOException, ServletException {

		//תΪHttpServletRequest
		HttpServletRequest req = (HttpServletRequest) request;
		HttpServletResponse res = (HttpServletResponse) response;
		//ݵ
		chain.doFilter(req, res);
		//ôHTTPACTION
		String actionName = getActionNameFromURI(req);
		//ViewManagerӦ
		ViewManager viewManager = new ViewManager(actionName);
		//вֵջ
		ValueStack valueStack = valueStackHelper.putIntoStack(req);
		//е󴫵ݸActionDispatcher
		String result = actionDispather.actionInvoke(actionName);
		String viewPath = viewManager.getViewPath(result);
		//ֱת
		RequestDispatcher rd = req.getRequestDispatcher(viewPath);
		rd.forward(req, res);
	}

	public void init(FilterConfig arg0) throws ServletException {
		/* 1XMLļǷȷ
		 * 2س򣬹۲ļǷȷ */
	}

	//ͨurlactionName
	private String getActionNameFromURI(HttpServletRequest req) {
		String path = (String) req.getRequestURI();
		String actionName = path.substring(path.lastIndexOf("/") + 1,
				path.lastIndexOf("."));
		return actionName;
	}

}
