package com.company.ch08simple_factory.section6;

import java.util.HashMap;
import java.util.Map;

/**
 * @author cbf4Life cbf4life@126.com
 *         I'm glad to share my knowledge with you all.
 */
public class Factory {
	private static final Map<String, Product> productMap = new HashMap<>();

	public static synchronized Product createProduct(String type)
			throws Exception {
		Product product = null;

		// MapѾ
		if (Factory.productMap.containsKey(type)) {
			product = Factory.productMap.get(type);
		} else {
			if (type.equals("Product1")) {
				product = new ConcreteProduct1();
			} else {
				product = new ConcreteProduct2();
			}
			// ͬʱѶŵ
			Factory.productMap.put(type, product);
		}
		return product;
	}
}
