package com.company.ch12proxy.section13.DynamicProxy;

import java.lang.reflect.InvocationHandler;

/**
 * @author cbf4Life cbf4life@126.com
 *         I'm glad to share my knowledge with you all.
 */
public class SubjectDynamicProxy<T> extends DynamicProxy<T> {

	public static <T> T newProxyInstance(T subject) {
		//ͨClassLoader,Ҳͨ		//		Subject.class.getInterfaces();
		ClassLoader loader = subject.getClass().getClassLoader();
		//ͨýӿ飬Ҳͨ		//		Subject.class.getClassLoader();
		Class<?>[] classes = subject.getClass().getInterfaces();

		//handler
		InvocationHandler handler = new MyInvocationHandler(subject);
		return DynamicProxy.newProxyInstance(loader, classes, handler);
	}
}
