package com.company.ch21composite.section2;

import java.util.ArrayList;

/**
 * @author cbf4Life cbf4life@126.com
 * I'm glad to share my knowledge with you all.
 * װνṹչʾ
 */
@SuppressWarnings("all") 
public class Client {

	public static void main(String[] args) {
		//װһ֯ṹ
		Branch ceo = compositeCorpTree();
		
		//ȰCEOϢӡ
		System.out.println(ceo.getInfo());
		
		//ȻԱϢ
		System.out.println(getTreeInfo(ceo));
	}
	
	//װ
	public static Branch compositeCorpTree(){
		//ȲܾCEO
		Branch root = new Branch("","ܾ",100000);
		//ž
		Branch developDep = new Branch("ȳ","зž",10000);
		Branch salesDep = new Branch("","۲ž",20000);
		Branch financeDep = new Branch("","񲿾",30000);
		
		//ٰС鳤
		Branch firstDevGroup = new Branch("ؿб","һ鳤",5000);
		Branch secondDevGroup = new Branch("","鳤",6000);
		
		//еС
		Leaf a = new Leaf("a","Ա",2000);
		Leaf b = new Leaf("b","Ա",2000);
		Leaf c = new Leaf("c","Ա",2000);
		Leaf d = new Leaf("d","Ա",2000);
		Leaf e = new Leaf("e","Ա",2000);
		Leaf f = new Leaf("f","Ա",2000);
		Leaf g = new Leaf("g","Ա",2000);
		Leaf h = new Leaf("h","Ա",5000);
		Leaf i = new Leaf("i","Ա",4000);
		Leaf j = new Leaf("j","Ա",5000);
		Leaf k = new Leaf("k","CEO",8000);
		Leaf zhengLaoLiu = new Leaf("֣","з",20000);
		
		//ʼװ
		//CEOžһ
		root.addSubordinate(k);
		root.addSubordinate(developDep);
		root.addSubordinate(salesDep);
		root.addSubordinate(financeDep);
		
		
		//з
		developDep.addSubordinate(zhengLaoLiu);
		developDep.addSubordinate(firstDevGroup);
		developDep.addSubordinate(secondDevGroup);
		
		
		
		//Сʲô
		firstDevGroup.addSubordinate(a);
		firstDevGroup.addSubordinate(b);
		firstDevGroup.addSubordinate(c);
		secondDevGroup.addSubordinate(d);
		secondDevGroup.addSubordinate(e);
		secondDevGroup.addSubordinate(f);
		
		//ٿ۲µԱ
		salesDep.addSubordinate(h);
		salesDep.addSubordinate(i);
		
		//һ
		financeDep.addSubordinate(j);
		
		return root;
	}
	
	//,ֻҪҸڵ㣬ҾܱеĽڵ
	public static String getTreeInfo(Branch root){
		ArrayList<ICorp> subordinateList = root.getSubordinate();
		String info = "";
		for(ICorp s :subordinateList){
			if(s instanceof Leaf){ //ԱֱӻϢ
				info = info + s.getInfo()+"\n";
			}else{ //ǸСͷĿ
				info = info + s.getInfo() +"\n"+ getTreeInfo((Branch)s);
			}
		}
		
		return info;
	}
	

}
