package com.company.ch26state.section2;

/**
 * @author cbf4Life cbf4life@126.com
 * I'm glad to share my knowledge with you all.
 * ݵʵ
 */
public class Lift implements ILift {
	private int state;
	
	public void setState(int state) {
		this.state = state;
	}

	//Źر
	public void close() {
		//ʲô״̬²ܹر
		switch(this.state){
			case OPENING_STATE:  //Թţͬʱ޸ĵ״̬
				this.closeWithoutLogic();  
				this.setState(CLOSING_STATE);
				break;
			case CLOSING_STATE:  //ݾǹ״̬ʲô
				//do nothing;
				break;
			case RUNNING_STATE: //УűǹرյģҲ˵
				//do nothing;
				break;
			case STOPPING_STATE:  //ֹͣ״̬ҲǹرյģʲôҲ
				//do nothing;
				break;
			}			
		
	}
		
	//ſ
	public void open() {
		//ʲô״̬ܿ
		switch(this.state){
			case OPENING_STATE: //Ѿų״̬ʲô
				//do nothing;
				break;
			case CLOSING_STATE: //ǵʱر״̬Կ
				this.openWithoutLogic();
				this.setState(OPENING_STATE);
				break;
			case RUNNING_STATE: //״̬ܿţʲô
				//do nothing;
				break;
			case STOPPING_STATE: //ֹͣ״̬ȻҪ
				this.openWithoutLogic();
				this.setState(OPENING_STATE);
				break;
		}
			
	}
	
	//ݿʼ
	public void run() {
		switch(this.state){
			case OPENING_STATE: //Ѿų״̬Уʲô
				//do nothing;
				break;
			case CLOSING_STATE: //ǵʱر״̬
				this.runWithoutLogic();
				this.setState(RUNNING_STATE);
				break;
			case RUNNING_STATE: //״̬ʲô
				//do nothing;
				break;
			case STOPPING_STATE: //ֹͣ״̬
				this.runWithoutLogic();
				this.setState(RUNNING_STATE);
		}
	}

	//ֹͣ
	public void stop() {
		switch(this.state){
			case OPENING_STATE: //Ѿų״̬ǿ϶Ҫͣģʲô
				//do nothing;
				break;
			case CLOSING_STATE: //ǵʱر״̬Ȼֹͣ
				this.stopWithoutLogic();
				this.setState(CLOSING_STATE);
				break;
			case RUNNING_STATE: //״̬еȻҲֹͣ
				this.stopWithoutLogic();
				this.setState(CLOSING_STATE);
				break;
			case STOPPING_STATE: //ֹͣ״̬ʲô
				//do nothing;
				break;
		}
	}
	
	//ĵݹţʵʵ߼
	private void closeWithoutLogic(){
		System.out.println("Źر...");
	}
	
	//ĵſκ
	private void openWithoutLogic(){
		System.out.println("ſ...");
	}
	
	//У
	private void runWithoutLogic(){
		System.out.println("...");
	}
	
	//ֹͣ
	private void stopWithoutLogic(){
		System.out.println("ֹͣ...");
	}
}
		