package com.company.ch26state.section3;

/**
 * @author cbf4Life cbf4life@126.com
 * I'm glad to share my knowledge with you all.
 */
public class Context {
	//еĵ״̬
	public final static OpenningState openningState = new OpenningState();
	public final static ClosingState closeingState = new ClosingState();
	public final static RunningState runningState = new RunningState();
	public final static StoppingState stoppingState = new StoppingState();
	
	//һǰ״̬
	private ElevatorState elevatorState;
	
	public ElevatorState getLiftState() {
		return elevatorState;
	}

	public void setElevatorState(ElevatorState elevatorState) {
		this.elevatorState = elevatorState;
		//ѵǰĻ֪ͨʵ
		this.elevatorState.setContext(this);
	}
	
	public void open(){
		this.elevatorState.open();
	}
	
	public void close(){
		this.elevatorState.close();
	}
	
	public void run(){
		this.elevatorState.run();
	}
	
	public void stop(){
		this.elevatorState.stop();
	}
}
