package com.company.ch30creator.AbstractFactory_vs_builder.builder;

/**
 * @author cbf4Life cbf4life@126.com
 * I'm glad to share my knowledge with you all.
 */
public class Director {
	
	//Խߵ
	private CarBuilder benzBuilder = new BenzBuilder();
	private CarBuilder bmwBuilder = new BMWBuilder();
	
	//SUV	
	public ICar createBenzSuv(){
		//
		return createCar(benzBuilder, "benz", "benz̥");
	}
	
	//һ
	public ICar createBMWVan(){
		return createCar(benzBuilder, "BMW", "BMW̥");		
	}
	
	//һϳ
	public ICar createComplexCar(){		
		return createCar(bmwBuilder, "BMW", "benz̥");
	}
	
	//
	private ICar createCar(CarBuilder _carBuilder,String engine,String wheel){
		//ݻͼ
		Blueprint bp = new Blueprint();
		bp.setEngine(engine);
		bp.setWheel(wheel);
		
		System.out.println("ͼ");
		_carBuilder.receiveBlueprint(bp);
		return _carBuilder.buildCar();
	}
	
}