package com.company.ch32behavior.observer_vs_chain.chain;

/**
 * @author cbf4Life cbf4life@126.com
 * I'm glad to share my knowledge with you all.
 */
public class ChinaTopDnsServer extends DnsServer {

	@Override
	protected Recorder echo(String domain) {
		Recorder recorder = super.echo(domain);
		recorder.setOwner("йDNS");
		return recorder;
	}

	
	@Override
	protected boolean isLocal(String domain) {
		return domain.endsWith(".cn");
	}

}
